<div class="container-fluid mt-4">

  <div class="card p-4">
    <div class="row">
      <div class="col-md-12">
        <h4>{{translate('title')}}</h4>
      </div>
    </div>

    <form [formGroup]="formGroup" (submit)="save()">
      <div class="row">
        <div class="col-md-12">
          <div class="form-group">
            <label for="descricao">{{translate('descricao')}}</label>
            <span class="field-required">*</span>
            <input type="text"
                   id="descricao"
                   name="descricao"
                   formControlName="descricao"
                   class="form-control"
                   pInputText>
            <app-form-error [form]="formGroup"
                            inputName="descricao"></app-form-error>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label for="dtDespesa">{{translate('data_despesa')}}</label>
            <span class="field-required">*</span>
            <p-calendar inputId="basic"
                        id="dtDespesa"
                        name="dtDespesa"
                        dataType="string"
                        dateFormat="dd/mm/yy"
                        formControlName="dtDespesa"
                        inputStyleClass="form-control"
                        [style]="{width: '100%'}">
            </p-calendar>
            <app-form-error [form]="formGroup"
                            inputName="dtDespesa"></app-form-error>
          </div>
        </div>

        <div class="col-md-4">
          <div class="form-group">
            <label for="categoria">{{translate('categoria')}}</label>
            <p-autoComplete id="categoria"
                            name="categoria"
                            appendTo="body"
                            field="descricao"
                            inputStyleClass="form-control"
                            formControlName="categoria"
                            [forceSelection]="true"
                            [dropdown]="true"
                            [suggestions]="categoriaList"
                            (completeMethod)="findCategorias($event)">
            </p-autoComplete>
          </div>
        </div>

        <div class="col-md-4">
          <div class="form-group">
            <label for="vlrDespesa">{{translate('valor_despesa')}}</label>
            <span class="field-required">*</span>
            <div class="p-inputgroup">
              <span class="p-inputgroup-addon p-0">
                <i class="fa fa-money-bill"></i>
              </span>
              <input type="text"
                     id="vlrDespesa"
                     name="vlrDespesa"
                     formControlName="vlrDespesa"
                     class="form-control"
                     currencyMask
                     [min]="0.01"
                     (ngModelChange)="onChangeVlrDespesa()"
                     pInputText>
            </div>
            <app-form-error [form]="formGroup"
                            inputName="vlrDespesa"></app-form-error>
          </div>
        </div>


      </div>

      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label for="formaPagamento">{{translate('forma_pagamento')}}</label>
            <span class="field-required">*</span>
            <p-dropdown [options]="formaPagamentoDropdown"
                        id="formaPagamento"
                        name="formaPagamento"
                        formControlName="formaPagamento"
                        (onChange)="onSelectFormaPagamento()"
                        [style]="{width: '100%'}"
                        optionValue="value"
                        optionLabel="label">
            </p-dropdown>
          </div>
        </div>

        <div class="col-md-4">
          <div class="form-group">
            <label for="qtdParcela">{{translate('qtd_parcela')}}</label>
            <span *ngIf="fieldIsEnabled('qtdParcela')" class="field-required">*</span>
            <input type="text"
                   id="qtdParcela"
                   name="qtdParcela"
                   formControlName="qtdParcela"
                   maxlength="3"
                   onlyNumber
                   class="form-control">
            <app-form-error [form]="formGroup"
                            inputName="qtdParcela"></app-form-error>
          </div>
        </div>

        <div class="col-md-4">
          <div class="form-group">
            <label for="categoria">{{translate('cartao')}}</label>
            <span *ngIf="fieldIsEnabled('cartao')" class="field-required">*</span>
            <p-autoComplete id="cartao"
                            name="cartao"
                            appendTo="body"
                            field="descricao"
                            inputStyleClass="form-control"
                            formControlName="cartao"
                            [forceSelection]="true"
                            [dropdown]="true"
                            [suggestions]="cartaoList"
                            (completeMethod)="findCartoes($event)">
            </p-autoComplete>
            <app-form-error [form]="formGroup"
                            inputName="cartao"></app-form-error>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="col-md-12">
          <div class="form-group">
            <label for="diaVencimento">{{translate('dia_vencimento')}}</label>
            <span *ngIf="fieldIsEnabled('diaVencimento')" class="field-required">*</span>
            <input type="text"
                   id="diaVencimento"
                   name="diaVencimento"
                   onlyNumber
                   formControlName="diaVencimento"
                   maxlength="2"
                   class="form-control"
                   pInputText>
            <app-form-error [form]="formGroup"
                            inputName="diaVencimento"></app-form-error>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="col-md-12">
          <div class="form-group">
            <label for="observacao">{{translate('observacoes')}}</label>
            <textarea type="text"
                      id="observacao"
                      name="observacao"
                      formControlName="observacao"
                      maxlength="500"
                      rows="3"
                      class="form-control">
            </textarea>
            <app-caracter-couting [valueToCouting]="formGroup.get('observacao').value"
                                  maxSize="500">
            </app-caracter-couting>
          </div>
        </div>
      </div>

      <div class="row mb-2">
        <div class="col-md-12">
          <p-accordion class="mt-2">
            <p-accordionTab header="Lista de rateios"
                            [disabled]="!this.formGroup.get('vlrDespesa').value">
              <app-table-custom [objectList]="formGroup.get('rateios').value"
                                [totalElements]="formGroup.get('rateios').value?.length"
                                [sortIsActive]="false"
                                [navigateToFormOnAdd]="false"
                                (onAddObject)="addRateio()"
                                (onEditObject)="editRateio($event)"
                                (onDeleteObject)="deleteRateio($event)"
                                [paginatorIsActive]="false"
                                [columns]="columnsRateio">
              </app-table-custom>
            </p-accordionTab>
          </p-accordion>
        </div>
      </div>

      <div *ngIf="formGroup.get('parcelas').value?.length > 0" class="row mb-4">
        <div class="col-md-12">
          <p-accordion class="mt-2">
            <p-accordionTab header="Lista de parcelas">
              <app-table-custom [objectList]="formGroup.get('parcelas').value"
                                [totalElements]="formGroup.get('parcelas').value.length"
                                [showButtonNew]="false"
                                [showButtonDelete]="false"
                                [showButtonEdit]="false"
                                [showTableCheckbox]="false"
                                [sortIsActive]="false"
                                [paginatorIsActive]="false"
                                [columns]="columns">
              </app-table-custom>
            </p-accordionTab>
          </p-accordion>
        </div>
      </div>

      <div class="row">
        <div class="col-md-12">
          <app-salvar [typeButton]="'submit'"></app-salvar>
          <app-cancelar (click)="back()"></app-cancelar>
        </div>
      </div>
    </form>
  </div>
</div>

<app-despesa-rateio [showDialog]="showDialogEditRateio"
                    [rateio]="rateioCurrent"
                    [maxValue]="getMaxValueRateio()"
                    (onClose)="onCloseRateio()"
                    (onSave)="saveRateio($event)">
</app-despesa-rateio>
